// -*- Mode: Java; indent-tabs-mode: t; tab-width: 4 -*-
// ---------------------------------------------------------------------------
// SquirrelJME
//     Copyright (C) Stephanie Gawroriski <xer@multiphasicapps.net>
// ---------------------------------------------------------------------------
// SquirrelJME is under the Mozilla Public License Version 2.0.
// See license.mkd for licensing and copyright information.
// ---------------------------------------------------------------------------

package net.multiphasicapps.io;

import cc.squirreljme.runtime.cldc.annotation.SquirrelJMEVendorApi;

/**
 * This represents the alphabet that is used for Base64.
 *
 * @since 2018/03/05
 */
@SquirrelJMEVendorApi
public enum Base64Alphabet
{
	/** The basic and MIME alphabet. */
	@SquirrelJMEVendorApi
	BASIC('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
		'L', 'M',
		'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
		'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
		'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
		'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '='),
	
	/** The URL alphabet. */
	@SquirrelJMEVendorApi
	URL('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
		'L', 'M',
		'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
		'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
		'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
		'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '-', '_', '='),
	
	/* End. */
	;
	
	/** The alphabet for the characters. */
	final char[] _alphabet;
	
	/**
	 * Initializes the alphabet.
	 *
	 * @param __alphabet The alphabet.
	 * @throws NullPointerException On null arguments.
	 * @since 2018/03/05
	 */
	Base64Alphabet(char... __alphabet)
		throws NullPointerException
	{
		if (__alphabet == null)
			throw new NullPointerException("NARG");
		
		this._alphabet = __alphabet;
	}
}

